/* $Id: backvisit.c,v 3.3 1992/09/16 14:43:22 cogito Exp $ */

/* LIGA backend module		*/
/* visit sequence procedures	*/
/* U. Kastens, 13. 1. 92	*/

#include "global.h"
/*
#include "LIGA.h"
#include "LIGAMacros.h"
*/
#include "ligaconsts.h"
#include "lookup_idl.h"
#include "backptg_gen.h"

#include "backvisit.h"
#include "BackNames.h"
#include "attrdecl.h"
#include "expr.h"
#include "incl.h"
#include "bool.h"

#define _TERMINATOR
/*#define _TERMINATOR   ,""
old PTG*/

Def tmpDef;

void TrSEQAttribution (sa)
	SEQAttribution	sa;
{	SEQAttribution	s;
	Attribution	a;
	PTGNode		procs, header;

pppNoVal = PTGNoVal ();

procs = PTGVisitProcFileHead ();
header = PTGVisitHeaderHead ();

foreachinSEQAttribution (sa, s, a) {
	TrAttribution (a, &procs, &header);
}

PTGOutFile ("visitprocs.c", PTGFile (procs) _TERMINATOR);
PTGOutFile ("visitprocs.h", PTGFile (header) _TERMINATOR);
}/*TrSEQAttribution*/


void TrAttribution (a, pprocs, pheader)
	Attribution	a;
	PTGNode *pprocs, *pheader;
{	PTGNode		decls, stmts, epilog;
	Prod		proddef;
	Symb		lhs;
	SEQEntity	rhs;
	SEQAttrrule	arules;
	int		sectno;
	char		*prodname;

tmpDef = lookup_def (prodidOfAttribution (a));
proddef = DefToProd (tmpDef);
prodname = GetBaseName (dnameOfProd (proddef));
rhs = rhsOfProd (proddef);
tmpDef = lookup_def (lhsOfProd (proddef));
lhs = DefToSymb (tmpDef);

sectno = 1;
arules = attrrulesOfAttribution (a);

while (arules) {
	(*pheader) = PTGSeq (*pheader,
		PTGVisitProcHeader (
			PTGVisitProcName (PTGNumb (sectno),
					PTGAsIs (prodname))));
	(*pprocs) = PTGSeq (*pprocs,
		PTGVisitProcHead (
			PTGVisitProcName (PTGNumb (sectno),
					PTGAsIs (prodname)),
			StackAttrNames (attrsOfSymb (lhs), sectno),
			PTGProdPtrTypeName (PTGAsIs (prodname)),
			StackAttrParamSpecs (attrsOfSymb (lhs), sectno)));

	decls = PTGNULL;
	stmts = PTGVisitEntry ();
	epilog = PTGNULL;

	TrInclSect (lhs, sectno, &decls, &stmts, &epilog);
	arules = TrVisitSection (arules, &decls, &stmts, rhs);
	(*pprocs) = PTGSeq (*pprocs, PTGSeq (PTGSeq (decls, stmts), epilog));

	sectno++;
	if (arules)
		(*pprocs) = PTGSeq (*pprocs,
		PTGVisitProcTail (
			PTGVisitProcName (PTGNumb (sectno),
					PTGAsIs (prodname))));
	else
		(*pprocs) = PTGSeq (*pprocs, PTGVisitProcEnd ());
}

}/*TrAttribution*/


Symb SymbDefInRhs (rhs, pos)
	SEQEntity	rhs;
	int		pos;
{	Entity		ent;
	bool		search = true;

while (search) {					/* not EBNF */
	retrievefirstSEQEntity (rhs, ent);
	if (typeof (ent) == KSymbol)
		if (--pos == 0) search = false;
	rhs = tailSEQEntity (rhs);
}
tmpDef = lookup_def (didOfSymbol (EntityToSymbol (ent)));
return (DefToSymb (tmpDef));
}/*SymbDefInRhs*/

int IsVisited (descno, sectstart, currarule)
	int		descno;
	SEQAttrrule	sectstart;
	SEQAttrrule	currarule;
{	SEQAttrrule	artravel;
	Attrrule	ar;

foreachinSEQAttrrule (sectstart, artravel, ar) {
	if (artravel == currarule) return (0);
	if (typeof (ar) == KVisit) {
		if (symbnoOfVisit (AttrruleToVisit (ar)) == descno)
			return (1);
	}
}
}/*IsVisited*/

SEQAttrrule TrVisitSection (arules, pdecls, pstmts, rhs)
	SEQAttrrule	arules;
	PTGNode		* pdecls, * pstmts;
	SEQEntity	rhs;
{	Attrrule	arule;
	Visit		vs;
	Symb		sydef;
	int		descno, vsord;
	int		more;
	SEQAttrrule	sectstart;

sectstart = arules;
more = (arules != NULL);

while (more) {
	retrievefirstSEQAttrrule (arules, arule);
	if (typeof (arule) == KCall)
		(*pstmts) = PTGSeq (*pstmts,
			PTGStmt (TrCall (AttrruleToCall(arule), isstmt)));
	else if (typeof (arule) == KVisit) {
		vs = AttrruleToVisit (arule);  
		descno = symbnoOfVisit (vs);
		vsord = ordOfVisit (vs);

		if (descno) {	/* descendant visit */
			sydef = SymbDefInRhs (rhs, descno);

			if (!IsVisited (descno, sectstart, arules))
				/* no previous visit to this descendant */
			(*pdecls) =
			PTGSeq (*pdecls,
				StackAttrDecls (
					attrsOfSymb (sydef),
					vsord,	/*  unused */
					descno));
			
			(*pstmts) =
			PTGSeq (*pstmts,
			  PTGDescVisit (
			    PTGDescName (PTGNumb (descno)),
			    PTGDescName (PTGNumb (descno)),
			    StackArgs (
			      attrsOfSymb (sydef),
			      vsord,
			      descno)));

		} else {	/* ancestor visit, section completed */
			more = 0;
		}/* ancestor */
	}/* visit */

	arules = tailSEQAttrrule (arules);
}/* while */

return (arules);
}/*TrVisitSection*/



