/* Output from p2c, the Pascal-to-C translator */
/* From input file "frame.h" */


/* $Id: tree.pp,v 7.6 91/06/23 16:23:45 waite Exp $ */
/* Copyright, 1989, Universitaet Paderborn */

/* $Id: frame.h,v 7.5 90/01/23 15:21:51 waite Exp $ */
/* Copyright, 1989, The Regents of the University of Colorado */


#include "p2c.h"


#define MAXTREEDEPTH    500




typedef struct POSITION {
  long LINE, COL;
} POSITION;

typedef enum {
  SYSINFORM, SYNTAXERROR, SCANNERERROR, CONDFAILS, IMPLCONDFAILS, QUAFAILS,
  INCLFAILS, SYSERROR, SYSLIMIT
} MESSAGETYPE;



Static POSITION GLOBPOS;


extern Void MESSAGE PP((MESSAGETYPE class_, long msgid, long gram, long line,
			long col));


/* $Id: attr_h.pp,v 1.2 89/10/20 16:41:42 waite Exp $ */
/* Copyright, 1989, Universitaet Paderborn */



#define MAXCODETERMCODE  3

/*&END GEN INCLUDE*/


#define EMPTYRULE       0
#define R410GEN         1
#define R411GEN         2
#define R412GEN         3
#define R413GEN         4
#define R414GEN         5
#define R415GEN         6
#define R417GEN         7
#define R418GEN         8
#define R419GEN         9
#define R420GEN         10
#define R421GEN         11
#define R422GEN         12
#define R423GEN         13
#define R424GEN         14
#define R425GEN         15
#define R426GEN         16
#define R427GEN         17
#define R428GEN         18
#define R429GEN         19
#define R430GEN         20
#define R431GEN         21
#define R432GEN         22
#define R433GEN         23
#define R434GEN         24
#define R435GEN         25
#define R436GEN         26
#define R437GEN         27
#define R438GEN         28
#define R439GEN         29
#define R440GEN         30
#define R441GEN         31
#define R442GEN         32
#define R443GEN         33
#define R444GEN         34
#define R445GEN         35
#define R446GEN         36
#define R447GEN         37
#define R448GEN         38
#define R449GEN         39
#define R450GEN         40
#define LISTRULE        41
#define TERMRULE        42
#define LISTEND         43


#define N303Identifier  2
#define N354IntegerValue  3
#define FIRSTTERM       1
#define LASTTERM        3


#define N304OIL         4
#define N308xStmtList   5
#define N310xOpRef      6
#define N312xStmt       7
#define N314xParamTypeDef  8
#define N315xParamList  9
#define N326xParamId    10
#define N328xForId      11
#define N329xTypeExpr   12
#define N332xTypeExprId  13
#define N334xCoerSig    14
#define N335xOpCost     15
#define N337xOpDef      16
#define N338xTypeId     17
#define N342xFuncSig    18
#define N343xArgSig     19
#define N345xBinOp      20
#define N347xTypeList   21
#define N350xIndDef     22
#define N351xOpList     23
#define FIRSTNTERM      4
#define LASTNTERM       23

#define MAXSYMB         2048

#define FIRSTALLTYPES   0
#define U87INT          0
#define U88BOOL         1
#define U89CHAR         2
#define U90SYMB         3
#define U91STRING       4
#define U92LIST         5
#define U144tKey        6
#define U147tObjKind    7
#define U149tTypeKind   8
#define U151tOpKind     9
#define U154tOilClass   10
#define U156tOilType    11
#define U158tOilOp      12
#define U160tStructTypeSet  13
#define U184tKeyList    14
#define U209tOilArgSig  15
#define U213tOilClassArgSig  16
#define U215tOilClassOp  17
#define U230tTypeKindSet  18
#define U231tArgSig     19
#define U232tTypeSet    20
#define U234tTypeSetOp  21
#define U245tAnyOp      22
#define U246tSetOp      23
#define U247tIdentPair  24
#define U250tIdentMap   25
#define U275tSetSig     26
#define U276tArgSetValues  27
#define U277tArgSetValue  28
#define U289tArgValues  29
#define U290tArgValue   30
#define U291tArgValueList  31
#define U307tEnv        32
#define U356tOilSetSig  33
#define U357tOilTypeSet  34
#define U361tOilClassOpId  35
#define U362tOilClassCoercion  36
#define U364tOilCoercionSeq  37
#define U452GEN         38
#define U453GEN         39
#define U454GEN         40
#define UNNODEPTR       41
#define UNARRAY         42
#define LASTALLTYPES    42

/*&END GEN INCLUDE*/
/* next 2 consts are used in UNIONTYPE */
#define MAXSTACK        10   /* INITIAL LENGTH OF ATTRIBUTE STACKS */
#define LINK_           11   /* MAXSTACK + 1: LINK OF ATTRIBUTE STACK UNITS */



/* ============ TREE NODE AND ATTRIBUTE TYPES =============== */

/* next 3 types are used in UNIONTYPE */
/* GENERAL TYPE FOR ATTRIBUTE STACKS:      */
/* ALL STACKS ARE MAPPED TO A UNIFORM      */
/* POINTER TYPE REFERRING STACK 'PORTIONS' */
/* RANGE OF A STACK POINTER   */
/* RANGE OF ONE STACK PORTION */

/* MUST INCLUDE STRINGTABLE RANGE OF GAG */
/*   "   */



/* imported data base types */

/* tKey: key of an object in the database;
   defined in dbtypes.h, imported here as a generic pointer
*/



/* tKeyList: a list of object keys;
   defined in dbtypes.h, imported here as a generic pointer
*/



/*
  $Id: oiladt2a.pp,v 1.8 90/04/05 08:50:40 swain Exp $
Copyright, 1989, The Regents of the University of Colorado
*/








/* types imported from environment module */

/* type of environment is defined in envmod.h:
   imported here as a generic pointer type
*/





typedef enum {
  S216eType, S217eOp, S218eClass, S219eErrorObj
} T147tObjKind;
typedef enum {
  S220ePrimType, S221eParamType, S222eForType, S223ePrimSet, S224eParamSet
} T149tTypeKind;
typedef enum {
  S225ePrimOp, S226eSetOp, S227eClassOp
} T151tOpKind;
typedef enum {
  S235eTSunion, S236eTSintersect, S237eTSdiff
} T234tTypeSetOp;

typedef struct TPLIST {
  struct TPLISTELEM *HEAD, *LAST;
} TPLIST;

typedef TPLIST T231tArgSig;
typedef TPLIST T232tTypeSet;
typedef TPLIST T246tSetOp;
typedef TPLIST T250tIdentMap;
typedef TPLIST T275tSetSig;
typedef TPLIST T276tArgSetValues;
typedef TPLIST T289tArgValues;
typedef TPLIST T291tArgValueList;
typedef TPLIST T452GEN;
typedef TPLIST T453GEN;
typedef TPLIST T454GEN;
typedef T147tObjKind atptObjKind;
typedef T149tTypeKind atptTypeKind;
typedef T151tOpKind atptOpKind;

typedef struct V160tStructTypeSet {

  TPLIST L233value;
} V160tStructTypeSet;

typedef struct V245tAnyOp {
  char DISCR;
  union {
    long *C158tOilOp;
    long *C215tOilClassOp;
    TPLIST C246tSetOp;
  } UU;
} V245tAnyOp;

typedef struct V247tIdentPair {

  long L248op, *L249indication;
} V247tIdentPair;

typedef struct V277tArgSetValue {

  Char *L253id;
  TPLIST L233value;
} V277tArgSetValue;

typedef struct V290tArgValue {

  Char *L253id;
  long *L233value;
} V290tArgValue;

typedef struct UNIONTYPE {
  char DISCR;
  union {
    long C87INT;
    boolean C88BOOL;
    Char C89CHAR;
    long C90SYMB;
    long C91STRING;
    Char *C144tKey;
    T147tObjKind C147tObjKind;
    T149tTypeKind C149tTypeKind;
    T151tOpKind C151tOpKind;
    long *C154tOilClass;
    long *C156tOilType;
    long *C158tOilOp;
    V160tStructTypeSet *C160tStructTypeSet;
    Char *C184tKeyList;
    long *C209tOilArgSig;
    long *C213tOilClassArgSig;
    long *C215tOilClassOp;
    long C230tTypeKindSet;
    T234tTypeSetOp C234tTypeSetOp;
    V245tAnyOp *C245tAnyOp;
    V247tIdentPair *C247tIdentPair;
    V277tArgSetValue *C277tArgSetValue;
    V290tArgValue *C290tArgValue;
    Char *C307tEnv;
    long *C356tOilSetSig;
    long *C357tOilTypeSet;
    long *C361tOilClassOpId;
    long *C362tOilClassCoercion;
    long *C364tOilCoercionSeq;
    TPLIST COLIST;
    struct NODE *CONODEPTR;
    struct UNIONTYPE *COARRAY;
  } UU;
} UNIONTYPE;

typedef UNIONTYPE ATARRAY[LINK_ + 1];

typedef struct TPLISTELEM {
  UNIONTYPE *ELEMENT;
  struct TPLISTELEM *NEXT;
} TPLISTELEM;


/*&END GEN INCLUDE*/


typedef union TERMATTYPE {
  long TERMAT;
  long id;
  long value;
} TERMATTYPE;

typedef struct NODE {
  struct NODE *BROTHER;
  char RULE;
  union {
    struct NODE *ELEMS;
    struct {
      POSITION POS;
      struct NODE *SONS;
      char NTSEL;
      union {
	struct {
	  Char *A304305defEnv, *A304306refEnv;
	  TPLIST A304254identMap;
	} U4;
	long *A308214class;
	struct {
	  long *A310249indication;
	  V247tIdentPair *A310311identification;
	  Char *A310162key;
	  T147tObjKind A310195otype;
	  T151tOpKind A310352operkind;
	} U6;
	struct {
	  Char *A312305defEnv, *A312306refEnv;
	  TPLIST A312461GEN;
	} U7;
	struct {
	  long *A314214class;
	  Char *A314305defEnv;
	} U8;
	struct {
	  long A315317len;
	  Char *A315305defEnv;
	} U9;
	long A335210cost;
	Char *A337162key;
	long A338253id;
      } UU;
    } U1;
    struct {
      char TERMSEL;
      TERMATTYPE TERMAT;
    } U42;
  } UU;
} NODE;


/*&END GEN INCLUDE*/


/* $Id: tree_h.pp,v 1.4 91/06/23 16:24:34 waite Exp $ */
/* Copyright, 1989, Universitaet Paderborn */



#define MAXINCLKEY      24


/*&END GEN INCLUDE*/





/*&END GEN INCLUDE*/

typedef struct GRUNDSYMBOLDESKRIPTOR {
  POSITION POS;
  long SYNTAXCODE, ATTR;
} GRUNDSYMBOLDESKRIPTOR;


Static NODE *CURRNODE;
Static short NODESTACKTOP;


/* for tree construction with a stack           */
/*PRE: NODESTACKTOP=1; NODESTACK[1]=NIL (dummy) */
/*INV: NODESTACKTOP=topmost entry               */
/*POST:NODESTACK[2]=root of tree                */

extern Void PUSHNODE PP((NODE *PTR));

extern NODE *POPNODE PV();

/* tree movements for attribute evaluation*/
/* PRE: stack as above, call TREENEXT to start with first tree*/
/* INV: CURRNODE->current node or CURRNODE=nil, see below */
/*      CURRNODE^.SONS resp. CURRNODE^.ELEMS are accessible */

extern Void TREENEXT PV();

/* Move to root of next tree to be evaluated.
   If nil evaluation stops */

extern Void TREEANCESTOR PV();

/*  move to ancestor */

extern Void TREEDESCENDANT PP((long I));

/*  move to I-th descendant */

extern Void TREEFIRSTELEM PV();

/*  move to first element of a listnode */

extern Void TREEBROTHER PV();

/* PRE: CURRNODE is list node, reached by an immediately
        preceeding TREEANCESTOR form an element */
/*  move to next element of the listnode */

extern Void EMPTYLIST PP((long ELZAHL));

extern Void ANFLIST PP((long ELZAHL));

extern Void CONTLIST PP((long ELZAHL));

extern Void EMPTYNODE PP((long I));

/* reaching up in the tree:*/
extern Void INCLUDING PP((int INCLKEY, UNIONTYPE *HIVAR));

extern char ANCRULETEST PV();

extern Void MAKENODE PP((int RULEIND, int NTIND, long SUCCS));

extern Void SourceInit PV();

/* Functions to construct new trees */

extern NODE *Leaf PP((long a));

extern NODE *Link PP((NODE *f, NODE *r));

extern NODE *Rule PP((long r, NODE *s));

extern boolean Tree PP((long n, NODE *t));

extern NODE *Bottom PV();

extern NODE *Empty PV();

extern NODE *EmptyL PV();

extern NODE *List PP((NODE *l));





/*  ERROR MESSAGES ACCORDING TO <USER>.C.SCANTAB:  */

#define INCLFAILSMSG    5   /* tree */
#define NODESTACKFULLMSG  12   /* tree and attr eval */
#define NODESTACKEMPTYMSG  13   /* tree */



Static NODE *CURRTOK, *INSERTTOK;
Static NODE *NODESTACK[MAXTREEDEPTH];

Static NODE *LASTCURRNODE;


Void PUSHNODE(PTR)
NODE *PTR;
{
  /* (PTR : NODEPTR) */
  if (NODESTACKTOP >= MAXTREEDEPTH)
    MESSAGE(SYSLIMIT, (long)NODESTACKFULLMSG, 0L, GLOBPOS.LINE, GLOBPOS.COL);
  NODESTACKTOP++;
  NODESTACK[NODESTACKTOP - 1] = PTR;
}  /* PUSHNODE */


NODE *POPNODE()
{
  /* : NODEPTR */
  NODE *RESULT;   /* P240-ERROR!!*/

  if (NODESTACKTOP <= 1)   /* 1 : DUMMYNODE!! */
    MESSAGE(SYSERROR, (long)NODESTACKEMPTYMSG, 0L, GLOBPOS.LINE, GLOBPOS.COL);
  RESULT = NODESTACK[NODESTACKTOP - 1];
  NODESTACKTOP--;
  return RESULT;
}  /* POPNODE */


Void INCLUDING(INCLKEY, HIVAR)
char INCLKEY;
UNIONTYPE *HIVAR;
{
  /* (     INCLKEY : INCLRANGE;
                           var HIVAR   : UNIONTYPE ) */
  boolean NOTFOUND;
  short INCLTOP;
  NODE *WITH;

  NOTFOUND = true;
  INCLTOP = NODESTACKTOP;
  while (INCLTOP > 1 && NOTFOUND) {
    WITH = NODESTACK[INCLTOP - 1];
    if (WITH->RULE != LISTRULE) {   /* EMPTYRULE AND TERMRULE CANNOT OCCUR */
      switch (INCLKEY) {

      case 1:
	if (WITH->UU.U1.NTSEL == N304OIL) {
	  NOTFOUND = false;
	  HIVAR->UU.C307tEnv = WITH->UU.U1.UU.U4.A304305defEnv;
	}
	break;

      case 3:
	if (WITH->UU.U1.NTSEL == N312xStmt) {
	  NOTFOUND = false;
	  HIVAR->UU.C307tEnv = WITH->UU.U1.UU.U7.A312306refEnv;
	}
	break;

      case 5:
	if (WITH->UU.U1.NTSEL == N315xParamList) {
	  NOTFOUND = false;
	  HIVAR->UU.C307tEnv = WITH->UU.U1.UU.U9.A315305defEnv;
	}
	break;

      case 6:
	if (WITH->UU.U1.NTSEL == N308xStmtList) {
	  NOTFOUND = false;
	  HIVAR->UU.C154tOilClass = WITH->UU.U1.UU.A308214class;
	}
	break;

      case 17:
	if (WITH->UU.U1.NTSEL == N304OIL) {
	  NOTFOUND = false;
	  HIVAR->UU.C307tEnv = WITH->UU.U1.UU.U4.A304306refEnv;
	}
	break;

      case 24:
	if (WITH->UU.U1.NTSEL == N304OIL) {
	  NOTFOUND = false;
	  HIVAR->UU.COLIST = WITH->UU.U1.UU.U4.A304254identMap;
	}
	break;

	/*&END GEN INCLUDE*/
      }/* CASE INCLKEY */
    }
    INCLTOP--;
  }  /* WHILE */
  if (NOTFOUND)
    MESSAGE(INCLFAILS, (long)INCLFAILSMSG, 0L, CURRNODE->UU.U1.POS.LINE,
	    CURRNODE->UU.U1.POS.COL);
}  /* INCLUDING */


char ANCRULETEST()
{
  /* : RULENRS  */
  /*===========*/
  short STACKIND;

  if (NODESTACK[NODESTACKTOP - 1]->RULE == LISTRULE)
    STACKIND = NODESTACKTOP - 1;
  else
    STACKIND = NODESTACKTOP;
  /* ASSERT(NOT NODESTACK[STACKIND]^.RULE IN [EMPTYRULE,LISTRULE..]); */
  return (NODESTACK[STACKIND - 1]->RULE);
}


Void TREENEXT()
{
  /* Move to root of next tree to be evaluated.
     If nil evaluation stops */
  if (NODESTACKTOP == 2) {
    /* first call:  root of tree after construction */
    CURRNODE = NODESTACK[1];
    NODESTACKTOP = 1;
  } else
    CURRNODE = NULL;
  /* second call: nil after last TREEANCESTOR */
}


Void TREEANCESTOR()
{
  /*  move to ancestor */
  /* assumes that bottom stack element is NIL */
  LASTCURRNODE = CURRNODE;
  CURRNODE = NODESTACK[NODESTACKTOP - 1];
  NODESTACKTOP--;
}


Void TREEDESCENDANT(I)
long I;
{
  /* (I : integer) */
  /*  move to I-th descendant */
  if (NODESTACKTOP >= MAXTREEDEPTH)
    MESSAGE(SYSLIMIT, (long)NODESTACKFULLMSG, 0L, CURRNODE->UU.U1.POS.LINE,
	    CURRNODE->UU.U1.POS.COL);
  NODESTACKTOP++;
  NODESTACK[NODESTACKTOP - 1] = CURRNODE;
  CURRNODE = CURRNODE->UU.U1.SONS;
  while (I > 1) {
    CURRNODE = CURRNODE->BROTHER;
    I--;
  }
}


Void TREEFIRSTELEM()
{
  /*  move to first element of a listnode */
  if (NODESTACKTOP >= MAXTREEDEPTH)
    MESSAGE(SYSLIMIT, (long)NODESTACKFULLMSG, 0L, CURRNODE->UU.U1.POS.LINE,
	    CURRNODE->UU.U1.POS.COL);
  NODESTACKTOP++;
  NODESTACK[NODESTACKTOP - 1] = CURRNODE;
  CURRNODE = CURRNODE->UU.ELEMS;
}


Void TREEBROTHER()
{
  /* PRE: be at a list node, reached by an immediately
          preceeding TREEANCESTOR form an element */
  /*  move to next element of the listnode */
  NODESTACKTOP++;   /* list node is still on top */
  CURRNODE = LASTCURRNODE->BROTHER;
}


/*===========================================================*/
/* Functions for parser driven tree construction             */
/*===========================================================*/

Void EMPTYLIST(ELZAHL)
long ELZAHL;
{
  /*ELZAHL:integer*/
  /*========*/
  NODE *NODEVAR;
  long I;


  /* IF ELZAHL > 0  THEN */

  for (I = 1; I <= ELZAHL; I++) {   /* ELSE ELZAHL = 0 */
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    NODEVAR->RULE = LISTRULE;
    NODEVAR->UU.ELEMS = NULL;
    NODEVAR->BROTHER = NULL;
    PUSHNODE(NODEVAR);
  }
/* p2c: tree.p, line 171:
 * Note: No SpecialMalloc form known for NODE.LISTRULE [187] */



}  /* EMPTYLIST */


Void ANFLIST(ELZAHL)
long ELZAHL;
{
  /* ELZAHL : integer */
  /*=======*/
  NODE *NODEVAR;
  long I;


  /* IF ELZAHL > 0 THEN */
  for (I = 0; I < ELZAHL; I++) {   /* ELSE ELZAHL = 0 */
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    NODEVAR->RULE = LISTRULE;
    NODEVAR->UU.ELEMS = NODESTACK[NODESTACKTOP - I - 1];
    NODEVAR->BROTHER = NULL;
    NODESTACK[NODESTACKTOP - I - 1] = NODEVAR;
  }
/* p2c: tree.p, line 193:
 * Note: No SpecialMalloc form known for NODE.LISTRULE [187] */
}  /* ANFLIST */


Void CONTLIST(ELZAHL)
long ELZAHL;
{
  /* ELZAHL : integer */
  /*========*/
  NODE *NODEVAR;
  long I;


  /* IF ELZAHL > 0 THEN */
  for (I = 1; I <= ELZAHL; I++) {   /* ELSE ELZAHL = 0 */
    NODEVAR = NODESTACK[NODESTACKTOP - ELZAHL - 1]->UU.ELEMS;
    while (NODEVAR->BROTHER != NULL)
      NODEVAR = NODEVAR->BROTHER;
    NODEVAR->BROTHER = POPNODE();
  }

}  /* CONTLIST */


Void EMPTYNODE(I)
long I;
{
  /*I : integer*/
  /*=========*/
  long J;
  NODE *NODEVAR;

  if (I <= 0)
    return;


  for (J = 1; J <= I; J++) {
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    NODEVAR->RULE = EMPTYRULE;
    NODEVAR->BROTHER = NULL;
    PUSHNODE(NODEVAR);
  }
/* p2c: tree.p, line 235:
 * Note: No SpecialMalloc form known for NODE.EMPTYRULE [187] */
}  /* EMPTYNODE */


Static Void MAKENONODE(NTIND)
char NTIND;
{
}  /*MAKENONODE*/


Void MAKENODE(RULEIND, NTIND, SUCCS)
char RULEIND;
char NTIND;
long SUCCS;
{
  /*RULEIND: RULENRS;
                        NTIND  : NTNRS;
                        SUCCS  : POSINT*/
  long I;
  NODE *SONSPTR, *NODEVAR;


  switch (RULEIND) {


  case R410GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 262:
 * Note: No SpecialMalloc form known for NODE.R410GEN.N304OIL [187] */
  case R411GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 263:
 * Note: No SpecialMalloc form known for NODE.R411GEN.N308XSTMTLIST [187] */
  case R412GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 264:
 * Note: No SpecialMalloc form known for NODE.R412GEN.N312XSTMT [187] */
  case R413GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 265: Note:
 * No SpecialMalloc form known for NODE.R413GEN.N314XPARAMTYPEDEF [187] */
  case R414GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 266:
 * Note: No SpecialMalloc form known for NODE.R414GEN.N326XPARAMID [187] */
  case R415GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 267: Note:
 * No SpecialMalloc form known for NODE.R415GEN.N315XPARAMLIST [187] */
  case R417GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 268: Note:
 * No SpecialMalloc form known for NODE.R417GEN.N315XPARAMLIST [187] */
  case R418GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 269: Note:
 * No SpecialMalloc form known for NODE.R418GEN.N315XPARAMLIST [187] */
  case R419GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 270:
 * Note: No SpecialMalloc form known for NODE.R419GEN.N312XSTMT [187] */
  case R420GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 271:
 * Note: No SpecialMalloc form known for NODE.R420GEN.N328XFORID [187] */
  case R421GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 272:
 * Note: No SpecialMalloc form known for NODE.R421GEN.N312XSTMT [187] */
  case R422GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 273: Note:
 * No SpecialMalloc form known for NODE.R422GEN.N332XTYPEEXPRID [187] */
  case R423GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 274:
 * Note: No SpecialMalloc form known for NODE.R423GEN.N312XSTMT [187] */
  case R424GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 275:
 * Note: No SpecialMalloc form known for NODE.R424GEN.N334XCOERSIG [187] */
  case R425GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 276:
 * Note: No SpecialMalloc form known for NODE.R425GEN.N312XSTMT [187] */
  case R426GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 277:
 * Note: No SpecialMalloc form known for NODE.R426GEN.N342XFUNCSIG [187] */
  case R427GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 278:
 * Note: No SpecialMalloc form known for NODE.R427GEN.N342XFUNCSIG [187] */
  case R428GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 279:
 * Note: No SpecialMalloc form known for NODE.R428GEN.N329XTYPEEXPR [187] */
  case R429GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 280:
 * Note: No SpecialMalloc form known for NODE.R429GEN.N329XTYPEEXPR [187] */
  case R430GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 281:
 * Note: No SpecialMalloc form known for NODE.R430GEN.N329XTYPEEXPR [187] */
  case R431GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 282:
 * Note: No SpecialMalloc form known for NODE.R431GEN.N329XTYPEEXPR [187] */
  case R432GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 283:
 * Note: No SpecialMalloc form known for NODE.R432GEN.N345XBINOP [187] */
  case R433GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 284:
 * Note: No SpecialMalloc form known for NODE.R433GEN.N345XBINOP [187] */
  case R434GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 285:
 * Note: No SpecialMalloc form known for NODE.R434GEN.N345XBINOP [187] */
  case R435GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 286:
 * Note: No SpecialMalloc form known for NODE.R435GEN.N345XBINOP [187] */
  case R436GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 287:
 * Note: No SpecialMalloc form known for NODE.R436GEN.N345XBINOP [187] */
  case R437GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 288:
 * Note: No SpecialMalloc form known for NODE.R437GEN.N347XTYPELIST [187] */
  case R438GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 289:
 * Note: No SpecialMalloc form known for NODE.R438GEN.N347XTYPELIST [187] */
  case R439GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 290:
 * Note: No SpecialMalloc form known for NODE.R439GEN.N347XTYPELIST [187] */
  case R440GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 291:
 * Note: No SpecialMalloc form known for NODE.R440GEN.N343XARGSIG [187] */
  case R441GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 292:
 * Note: No SpecialMalloc form known for NODE.R441GEN.N343XARGSIG [187] */
  case R442GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 293:
 * Note: No SpecialMalloc form known for NODE.R442GEN.N343XARGSIG [187] */
  case R443GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 294:
 * Note: No SpecialMalloc form known for NODE.R443GEN.N338XTYPEID [187] */
  case R444GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 295:
 * Note: No SpecialMalloc form known for NODE.R444GEN.N312XSTMT [187] */
  case R445GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 296:
 * Note: No SpecialMalloc form known for NODE.R445GEN.N350XINDDEF [187] */
  case R446GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 297:
 * Note: No SpecialMalloc form known for NODE.R446GEN.N337XOPDEF [187] */
  case R447GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 298:
 * Note: No SpecialMalloc form known for NODE.R447GEN.N351XOPLIST [187] */
  case R448GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 299:
 * Note: No SpecialMalloc form known for NODE.R448GEN.N310XOPREF [187] */
  case R449GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

/* p2c: tree.p, line 300:
 * Note: No SpecialMalloc form known for NODE.R449GEN.N335XOPCOST [187] */
  case R450GEN:
    NODEVAR = (NODE *)Malloc(sizeof(NODE));
    break;

    /*&END GEN INCLUDE*/

/* p2c: tree.p, line 305:
 * Note: No SpecialMalloc form known for NODE.R450GEN.N335XOPCOST [187] */
  }/*case RULEIND*/

  NODEVAR->RULE = RULEIND;
  /* IF NOT (RULEIND IN [EMPTYRULE, LISTRULE,  TERMRULE] THEN */
  /* EMPTYRULE , LISTRULE, TERMRULE KOMMT ABER NICHT VOR */
  NODEVAR->UU.U1.NTSEL = NTIND;
  NODEVAR->UU.U1.POS = GLOBPOS;
  NODEVAR->BROTHER = NULL;

  NODEVAR->UU.U1.SONS = NULL;
  for (I = SUCCS; I >= 1; I--) {
    SONSPTR = POPNODE();
    SONSPTR->BROTHER = NODEVAR->UU.U1.SONS;
    NODEVAR->UU.U1.SONS = SONSPTR;
  }
  PUSHNODE(NODEVAR);

}


/*===========================================================*/
/* PGS-Parser interface routines:                            */
/*===========================================================*/

Static Void SourceLeaf(D)
GRUNDSYMBOLDESKRIPTOR *D;
{
  if (INSERTTOK == NULL) {
    CURRTOK->UU.U42.TERMSEL = D->SYNTAXCODE;
    CURRTOK->UU.U42.TERMAT.TERMAT = D->ATTR;
    PUSHNODE(CURRTOK);
/* p2c: tree.p, line 339:
 * Note: No SpecialMalloc form known for NODE.TERMRULE [187] */
    CURRTOK = (NODE *)Malloc(sizeof(NODE));
    CURRTOK->RULE = TERMRULE;
    return;
  }
  INSERTTOK->UU.U42.TERMSEL = D->SYNTAXCODE;
  INSERTTOK->UU.U42.TERMAT.TERMAT = D->ATTR;
  PUSHNODE(INSERTTOK);
  INSERTTOK = NULL;
}


/*
procedure SourceNode(PR : integer; var D: GRUNDSYMBOLDESKRIPTOR);
begin
  GLOBPOS := D.POS;
  case PR of
*/
/*&INCLUDE PGS_GEN_STRUKTURANKNUEPFUNGEN*/
/*&END GEN INCLUDE*/
/*
  end;

end;*/
/*SourceNode*/

Void SourceInit()
{
  INSERTTOK = NULL;
/* p2c: tree.p, line 364:
 * Note: No SpecialMalloc form known for NODE.TERMRULE [187] */
  CURRTOK = (NODE *)Malloc(sizeof(NODE));
  CURRTOK->RULE = TERMRULE;
  NODESTACKTOP = 1;
  NODESTACK[0] = NULL;
  CURRNODE = NULL;
  GLOBPOS.LINE = 1;
  GLOBPOS.COL = 1;
}


/* Functions to construct new trees */

NODE *Leaf(a)
long a;
{
  /*a: integer): NODEPTR*/
  /* Build a terminal node with attribute a */
  NODE *p;

/* p2c: tree.p, line 376:
 * Note: No SpecialMalloc form known for NODE.TERMRULE [187] */
  p = (NODE *)Malloc(sizeof(NODE));
  p->BROTHER = NULL;
  p->RULE = TERMRULE;
  p->UU.U42.TERMSEL = 0;
  p->UU.U42.TERMAT.TERMAT = a;
  return p;
}


NODE *Link(f, r)
NODE *f, *r;
{
  /*f,r: NODEPTR): NODEPTR*/
  /* Make r the brother of f */
  if (f == NULL || r == NULL)
    return NULL;
  else {
    f->BROTHER = r;
    return f;
  }
}


NODE *Rule(r, s)
long r;
NODE *s;
{
  /*r: integer; s: NODEPTR): NODEPTR*/
  /* Build a node for rule r with sons s */
  NODE *p;

  if (s == NULL)
    return NULL;
  else {
    p = (NODE *)Malloc(sizeof(NODE));
    p->BROTHER = NULL;
    p->RULE = r;
    p->UU.U1.POS = GLOBPOS;
    p->UU.U1.SONS = s;
    p->UU.U1.NTSEL = 1;
    return p;
  }
}


boolean Tree(n, t)
long n;
NODE *t;
{
  /*n: integer; t: NODEPTR): boolean*/
  /* Establish a tree to be processed
     On entry-
        The root is current
     On exit-
        The nth subtree of the root is t
  */
  NODE *p;

  if (t == NULL)
    return true;
  p = CURRNODE->UU.U1.SONS;
  while (n > 2) {
    n--;
    p = p->BROTHER;
  }
  p->BROTHER = t;
  return true;
}


NODE *Bottom()
{
  /*: NODEPTR*/
  /* Establish an invalid tree */
  return NULL;
}


NODE *Empty()
{
  /*: NODEPTR*/
  /* Establish an empty optional tree */
  NODE *p;

/* p2c: tree.p, line 427:
 * Note: No SpecialMalloc form known for NODE.EMPTYRULE [187] */
  p = (NODE *)Malloc(sizeof(NODE));
  p->BROTHER = NULL;
  p->RULE = EMPTYRULE;
  return p;
}


NODE *EmptyL()
{
  /*: NODEPTR*/
  /* Establish an empty list */
  NODE *p;

/* p2c: tree.p, line 435:
 * Note: No SpecialMalloc form known for NODE.LISTRULE [187] */
  p = (NODE *)Malloc(sizeof(NODE));
  p->BROTHER = NULL;
  p->RULE = LISTRULE;
  p->UU.ELEMS = NULL;
  return p;
}


NODE *List(l)
NODE *l;
{
  /*l: NODEPTR): NODEPTR*/
  /* Establish a list node
     On entry-
        l=root of the list
  */
  NODE *p;

  if (l == NULL)
    return NULL;
  else {
    p = (NODE *)Malloc(sizeof(NODE));
    p->BROTHER = NULL;
    p->RULE = LISTRULE;
    p->UU.ELEMS = l;
    return p;
  }

/* p2c: tree.p, line 448:
 * Note: No SpecialMalloc form known for NODE.LISTRULE [187] */
}





/* End. */
